Description

The serialVersion in SystemMetadata allows for consistency between updates of systemMetadata

systemMetadata can only be updated on the CN

systemMetadata is managed by Hazelcast

Every operation that manipulated SystemMetadata on the CN will follow the pattern:

lock(); get();  increment(); put(); unlock();

if (hzSystemMetadata.tryLock(pid, 500L, TimeUnit.MILLISECONDS)) {

Systemmetadata systemMetadata = hzSystemMetadata.get(pid);

do something here

  systemMetadata.setSerialVersion

                (systemMetadata.getSerialVersion().add(BigInteger.ONE));

  hzSystemMetadata.put(systemMetadata);

  hzSystemMetadata.unlock(pid);

 

}

and of course you'll want the above in a try catch block too, so that if an exception is raised, a lock will still be released

Locking will be performed on the hzSystemMetadata HazelcastMap

Get will be performed against the hzSystemMetadata HazelcastMap

increment is an operation performed on the SystemMetadata.serialVersion. 

Put will be performed against the hzSystemMetadata HazelcastMap

Unlocking will be performed on the Hazelcast Lock structure

Subtasks:

Task # 1979: Update synchronization to use the locking and serialversion algorithm Closed

Task # 1980: Update replication to use the locking and serialVersion algorithm Closed

Task # 1981: Update CNReplication implementation to use the locking and serialVersion a... Closed

  Task # 1991: Update CNReplication and CNAuthorization interfaces with serialVersion change Closed

  Task # 1992: Update CNode implementation with serialVersion Additions Closed

  Task # 1993: Update Metacat implementation to support serialVersion additions Closed

  Task # 1994: Update CNReplication proxy classes to support serialVersion additions Closed

  Task # 1995: Update Metacat auth implementation to support serialVersion additions Closed

  Task # 1996: Update CNAuthorization proxy classes to support serialVersion additions Closed

Task # 1982: Update CNAuthorization implementation to use the locking and serialVersion... Closed

Related issues:
Related to Infrastructure - Story #1966: CNs should keep all replica MNs up t... Closed 2011-11-01 2011-11-19

History

#1 - 2011-11-07 18:09 - Dave Vieglais

- Target version changed from Sprint-2011.44-Block.6 to Sprint-2011.45-Block.6

- Position set to 1

#2 - 2011-11-15 03:34 - Dave Vieglais

- Target version changed from Sprint-2011.45-Block.6 to Sprint-2011.46-Block.6

- Position deleted (9)

- Position set to 1

#3 - 2011-11-15 17:52 - Robert Waltz

- Status changed from New to Closed
